Package virtuoso.javax

## Class BaseRowSet

- java.lang.Object
- - virtuoso.javax.BaseRowSet

All Implemented Interfaces:
  `java.io.Serializable`, `java.lang.AutoCloseable`, `java.sql.ResultSet`, `java.sql.Wrapper`, `javax.sql.RowSet`

Direct Known Subclasses:
  `OPLCachedRowSet`, `OPLJdbcRowSet`

    public abstract class BaseRowSet
    extends java.lang.Object
    implements javax.sql.RowSet, java.io.Serializable

See Also:
  Serialized Form

### Nested Class Summary

Nested Classes
`protected class` `BaseRowSet.Parameter`

### Field Summary

Fields
`protected static int` `ev_CursorMoved`
`protected static int` `ev_RowChanged`
`protected static int` `ev_RowSetChanged`
`protected java.util.Map<java.lang.String,java.lang.Class<?>>` `map`

### Fields inherited from interface java.sql.ResultSet

`CLOSE_CURSORS_AT_COMMIT, CONCUR_READ_ONLY, CONCUR_UPDATABLE, FETCH_FORWARD, FETCH_REVERSE, FETCH_UNKNOWN, HOLD_CURSORS_OVER_COMMIT, TYPE_FORWARD_ONLY, TYPE_SCROLL_INSENSITIVE, TYPE_SCROLL_SENSITIVE`

### Constructor Summary

Constructors
`BaseRowSet​()`

### Method Summary

All Methods Instance Methods Concrete Methods Deprecated Methods
`void` `addRowSetListener​(javax.sql.RowSetListener rowsetlistener)` RowSet listener registration.
`void` `clearParameters​()` In general, parameter values remain in force for repeated use of a RowSet.
`void` `close​()`
`java.lang.String` `getCommand​()` Get the rowset's command property.
`int` `getConcurrency​()` Get the rowset concurrency.
`java.lang.String` `getDataSourceName​()` The JNDI name that identifies a JDBC data source.
`boolean` `getEscapeProcessing​()` If escape scanning is on (the default), the driver will do escape substitution before sending the SQL to the database.
`int` `getFetchDirection​()` Determine the fetch direction.
`int` `getFetchSize​()` Determine the default fetch size.
`int` `getMaxFieldSize​()` The maxFieldSize limit (in bytes) is the maximum amount of data returned for any column value; it only applies to BINARY, VARBINARY, LONGVARBINARY, CHAR, VARCHAR, and LONGVARCHAR columns.
`int` `getMaxRows​()` The maxRows limit is the maximum number of rows that a RowSet can contain.
`protected BaseRowSet.Parameter` `getParam​(int paramIndex)`
`java.lang.Object[]` `getParams​()` Get the parameters that were set on the rowset.
`java.lang.String` `getPassword​()` The password used to create a database connection.
`int` `getQueryTimeout​()` The queryTimeout limit is the number of seconds the driver will wait for a Statement to execute.
`int` `getTransactionIsolation​()` The transaction isolation property contains the JDBC transaction isolation level used.
`int` `getType​()` Return the type of this result set.
`java.util.Map<java.lang.String,java.lang.Class<?>>` `getTypeMap​()` Get the type-map object associated with this rowset.
`java.lang.String` `getUrl​()` Get the url used to create a JDBC connection.
`java.lang.String` `getUsername​()` The username used to create a database connection.
`boolean` `isReadOnly​()` A rowset may be read-only.
`protected void` `notifyListener​(int event)`
`void` `removeRowSetListener​(javax.sql.RowSetListener rowsetlistener)` RowSet listener deregistration.
`void` `setArray​(int parameterIndex, java.sql.Array x)` Set an Array parameter.
`void` `setAsciiStream​(int parameterIndex, java.io.InputStream x)` Sets the designated parameter in this `RowSet` object's command to the given input stream.
`void` `setAsciiStream​(int parameterIndex, java.io.InputStream x, int length)` When a very large ASCII value is input to a LONGVARCHAR parameter, it may be more practical to send it via a java.io.InputStream.
`void` `setAsciiStream​(java.lang.String parameterName, java.io.InputStream x)` Sets the designated parameter to the given input stream.
`void` `setAsciiStream​(java.lang.String parameterName, java.io.InputStream x, int length)` Sets the designated parameter to the given input stream, which will have the specified number of bytes.
`void` `setBigDecimal​(int parameterIndex, java.math.BigDecimal x)` Set a parameter to a java.lang.BigDecimal value.
`void` `setBigDecimal​(java.lang.String parameterName, java.math.BigDecimal x)` Sets the designated parameter to the given `java.math.BigDecimal` value.
`void` `setBinaryStream​(int parameterIndex, java.io.InputStream x)` Sets the designated parameter in this `RowSet` object's command to the given input stream.
`void` `setBinaryStream​(int parameterIndex, java.io.InputStream x, int length)` When a very large binary value is input to a LONGVARBINARY parameter, it may be more practical to send it via a java.io.InputStream.
`void` `setBinaryStream​(java.lang.String parameterName, java.io.InputStream x)` Sets the designated parameter to the given input stream.
`void` `setBinaryStream​(java.lang.String parameterName, java.io.InputStream x, int length)` Sets the designated parameter to the given input stream, which will have the specified number of bytes.
`void` `setBlob​(int parameterIndex, java.io.InputStream inputStream)` Sets the designated parameter to a `InputStream` object.
`void` `setBlob​(int parameterIndex, java.io.InputStream inputStream, long length)` Sets the designated parameter to a `InputStream` object.
`void` `setBlob​(int parameterIndex, java.sql.Blob x)` Set a BLOB parameter.
`void` `setBlob​(java.lang.String parameterName, java.io.InputStream inputStream)` Sets the designated parameter to a `InputStream` object.
`void` `setBlob​(java.lang.String parameterName, java.io.InputStream inputStream, long length)` Sets the designated parameter to a `InputStream` object.
`void` `setBlob​(java.lang.String parameterName, java.sql.Blob x)` Sets the designated parameter to the given `java.sql.Blob` object.
`void` `setBoolean​(int parameterIndex, boolean x)` Set a parameter to a Java boolean value.
`void` `setBoolean​(java.lang.String parameterName, boolean x)` Sets the designated parameter to the given Java `boolean` value.
`void` `setByte​(int parameterIndex, byte x)` Set a parameter to a Java byte value.
`void` `setByte​(java.lang.String parameterName, byte x)` Sets the designated parameter to the given Java `byte` value.
`void` `setBytes​(int parameterIndex, byte[] x)` Set a parameter to a Java array of bytes.
`void` `setBytes​(java.lang.String parameterName, byte[] x)` Sets the designated parameter to the given Java array of bytes.
`void` `setCharacterStream​(int parameterIndex, java.io.Reader reader)` Sets the designated parameter in this `RowSet` object's command to the given `Reader` object.
`void` `setCharacterStream​(int parameterIndex, java.io.Reader x, int length)` When a very large UNICODE value is input to a LONGVARCHAR parameter, it may be more practical to send it via a java.io.Reader.
`void` `setCharacterStream​(java.lang.String parameterName, java.io.Reader reader)` Sets the designated parameter to the given `Reader` object.
`void` `setCharacterStream​(java.lang.String parameterName, java.io.Reader reader, int length)` Sets the designated parameter to the given `Reader` object, which is the given number of characters long.
`void` `setClob​(int parameterIndex, java.io.Reader reader)` Sets the designated parameter to a `Reader` object.
`void` `setClob​(int parameterIndex, java.io.Reader reader, long length)` Sets the designated parameter to a `Reader` object.
`void` `setClob​(int parameterIndex, java.sql.Clob x)` Set a CLOB parameter.
`void` `setClob​(java.lang.String parameterName, java.io.Reader reader)` Sets the designated parameter to a `Reader` object.
`void` `setClob​(java.lang.String parameterName, java.io.Reader reader, long length)` Sets the designated parameter to a `Reader` object.
`void` `setClob​(java.lang.String parameterName, java.sql.Clob x)` Sets the designated parameter to the given `java.sql.Clob` object.
`void` `setCommand​(java.lang.String s)` Set the rowset's command property.
`void` `setConcurrency​(int i)` Set the rowset concurrency.
`void` `setDataSourceName​(java.lang.String s)` Set the data source name.
`void` `setDate​(int parameterIndex, java.sql.Date x)` Set a parameter to a java.sql.Date value.
`void` `setDate​(int parameterIndex, java.sql.Date x, java.util.Calendar cal)` Set a parameter to a java.sql.Date value.
`void` `setDate​(java.lang.String parameterName, java.sql.Date x)` Sets the designated parameter to the given `java.sql.Date` value using the default time zone of the virtual machine that is running the application.
`void` `setDate​(java.lang.String parameterName, java.sql.Date x, java.util.Calendar cal)` Sets the designated parameter to the given `java.sql.Date` value, using the given `Calendar` object.
`void` `setDouble​(int parameterIndex, double x)` Set a parameter to a Java double value.
`void` `setDouble​(java.lang.String parameterName, double x)` Sets the designated parameter to the given Java `double` value.
`void` `setEscapeProcessing​(boolean flag)` If escape scanning is on (the default), the driver will do escape substitution before sending the SQL to the database.
`void` `setFetchDirection​(int direction)` Give a hint as to the direction in which the rows in this result set will be processed.
`void` `setFetchSize​(int rows)` Give the JDBC driver a hint as to the number of rows that should be fetched from the database when more rows are needed for this result set.
`void` `setFloat​(int parameterIndex, float x)` Set a parameter to a Java float value.
`void` `setFloat​(java.lang.String parameterName, float x)` Sets the designated parameter to the given Java `float` value.
`void` `setInt​(int parameterIndex, int x)` Set a parameter to a Java int value.
`void` `setInt​(java.lang.String parameterName, int x)` Sets the designated parameter to the given Java `int` value.
`void` `setLong​(int parameterIndex, long x)` Set a parameter to a Java long value.
`void` `setLong​(java.lang.String parameterName, long x)` Sets the designated parameter to the given Java `long` value.
`void` `setMaxFieldSize​(int max)` The maxFieldSize limit (in bytes) is set to limit the size of data that can be returned for any column value; it only applies to BINARY, VARBINARY, LONGVARBINARY, CHAR, VARCHAR, and LONGVARCHAR fields.
`void` `setMaxRows​(int max)` The maxRows limit is set to limit the number of rows that any RowSet can contain.
`void` `setNCharacterStream​(int parameterIndex, java.io.Reader value)` Sets the designated parameter in this `RowSet` object's command to a `Reader` object.
`void` `setNCharacterStream​(int parameterIndex, java.io.Reader value, long length)` Sets the designated parameter to a `Reader` object.
`void` `setNCharacterStream​(java.lang.String parameterName, java.io.Reader value)` Sets the designated parameter to a `Reader` object.
`void` `setNCharacterStream​(java.lang.String parameterName, java.io.Reader value, long length)` Sets the designated parameter to a `Reader` object.
`void` `setNClob​(int parameterIndex, java.io.Reader reader)` Sets the designated parameter to a `Reader` object.
`void` `setNClob​(int parameterIndex, java.io.Reader reader, long length)` Sets the designated parameter to a `Reader` object.
`void` `setNClob​(int parameterIndex, java.sql.NClob value)` Sets the designated parameter to a `java.sql.NClob` object.
`void` `setNClob​(java.lang.String parameterName, java.io.Reader reader)` Sets the designated parameter to a `Reader` object.
`void` `setNClob​(java.lang.String parameterName, java.io.Reader reader, long length)` Sets the designated parameter to a `Reader` object.
`void` `setNClob​(java.lang.String parameterName, java.sql.NClob value)` Sets the designated parameter to a `java.sql.NClob` object.
`void` `setNString​(int parameterIndex, java.lang.String value)` Sets the designated paramter to the given `String` object.
`void` `setNString​(java.lang.String parameterName, java.lang.String value)` Sets the designated paramter to the given `String` object.
`void` `setNull​(int parameterIndex, int sqlType)` Set a parameter to SQL NULL.
`void` `setNull​(int parameterIndex, int sqlType, java.lang.String typeName)` Sets the designated parameter to SQL NULL.
`void` `setNull​(java.lang.String parameterName, int sqlType)` Sets the designated parameter to SQL `NULL`.
`void` `setNull​(java.lang.String parameterName, int sqlType, java.lang.String typeName)` Sets the designated parameter to SQL `NULL`.
`void` `setObject​(int parameterIndex, java.lang.Object x)` Set the value of a parameter using an object; use the java.lang equivalent objects for integral values.
`void` `setObject​(int parameterIndex, java.lang.Object x, int targetSqlType)` This method is like setObject above, but the scale used is the scale of the second parameter.
`void` `setObject​(int parameterIndex, java.lang.Object x, int targetSqlType, int scale)` Set the value of a parameter using an object; use the java.lang equivalent objects for integral values.
`void` `setObject​(java.lang.String parameterName, java.lang.Object x)` Sets the value of the designated parameter with the given object.
`void` `setObject​(java.lang.String parameterName, java.lang.Object x, int targetSqlType)` Sets the value of the designated parameter with the given object.
`void` `setObject​(java.lang.String parameterName, java.lang.Object x, int targetSqlType, int scale)` Sets the value of the designated parameter with the given object.
`void` `setPassword​(java.lang.String s)` Set the password.
`void` `setQueryTimeout​(int seconds)` The queryTimeout limit is the number of seconds the driver will wait for a Statement to execute.
`void` `setReadOnly​(boolean value)` Set the read-onlyness of the rowset
`void` `setRef​(int parameterIndex, java.sql.Ref x)` Set a REF(<structured-type>) parameter.
`void` `setRowId​(int parameterIndex, java.sql.RowId x)` Sets the designated parameter to the given `java.sql.RowId` object.
`void` `setRowId​(java.lang.String parameterName, java.sql.RowId x)` Sets the designated parameter to the given `java.sql.RowId` object.
`void` `setShort​(int parameterIndex, short x)` Set a parameter to a Java short value.
`void` `setShort​(java.lang.String parameterName, short x)` Sets the designated parameter to the given Java `short` value.
`void` `setSQLXML​(int parameterIndex, java.sql.SQLXML xmlObject)` Sets the designated parameter to the given `java.sql.SQLXML` object.
`void` `setSQLXML​(java.lang.String parameterName, java.sql.SQLXML xmlObject)` Sets the designated parameter to the given `java.sql.SQLXML` object.
`void` `setString​(int parameterIndex, java.lang.String x)` Set a parameter to a Java String value.
`void` `setString​(java.lang.String parameterName, java.lang.String x)` Sets the designated parameter to the given Java `String` value.
`void` `setTime​(int parameterIndex, java.sql.Time x)` Set a parameter to a java.sql.Time value.
`void` `setTime​(int parameterIndex, java.sql.Time x, java.util.Calendar cal)` Set a parameter to a java.sql.Time value.
`void` `setTime​(java.lang.String parameterName, java.sql.Time x)` Sets the designated parameter to the given `java.sql.Time` value.
`void` `setTime​(java.lang.String parameterName, java.sql.Time x, java.util.Calendar cal)` Sets the designated parameter to the given `java.sql.Time` value, using the given `Calendar` object.
`void` `setTimestamp​(int parameterIndex, java.sql.Timestamp x)` Set a parameter to a java.sql.Timestamp value.
`void` `setTimestamp​(int parameterIndex, java.sql.Timestamp x, java.util.Calendar cal)` Set a parameter to a java.sql.Timestamp value.
`void` `setTimestamp​(java.lang.String parameterName, java.sql.Timestamp x)` Sets the designated parameter to the given `java.sql.Timestamp` value.
`void` `setTimestamp​(java.lang.String parameterName, java.sql.Timestamp x, java.util.Calendar cal)` Sets the designated parameter to the given `java.sql.Timestamp` value, using the given `Calendar` object.
`void` `setTransactionIsolation​(int value)` Set the transaction isolation.
`void` `setType​(int value)` Set the type of this result set.
`void` `setTypeMap​(java.util.Map<java.lang.String,java.lang.Class<?>> value)` Install a type-map object as the default type-map for this rowset.
`void` `setUnicodeStream​(int parameterIndex, java.io.InputStream x, int length)` Deprecated.
`void` `setUrl​(java.lang.String s)` Set the url used to create a connection.
`void` `setURL​(int parameterIndex, java.net.URL x)` Sets the designated parameter to the given `java.net.URL` value.
`void` `setUsername​(java.lang.String s)` Set the user name.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface java.sql.ResultSet

`absolute, afterLast, beforeFirst, cancelRowUpdates, clearWarnings, deleteRow, findColumn, first, getArray, getArray, getAsciiStream, getAsciiStream, getBigDecimal, getBigDecimal, getBigDecimal, getBigDecimal, getBinaryStream, getBinaryStream, getBlob, getBlob, getBoolean, getBoolean, getByte, getByte, getBytes, getBytes, getCharacterStream, getCharacterStream, getClob, getClob, getCursorName, getDate, getDate, getDate, getDate, getDouble, getDouble, getFloat, getFloat, getHoldability, getInt, getInt, getLong, getLong, getMetaData, getNCharacterStream, getNCharacterStream, getNClob, getNClob, getNString, getNString, getObject, getObject, getObject, getObject, getObject, getObject, getRef, getRef, getRow, getRowId, getRowId, getShort, getShort, getSQLXML, getSQLXML, getStatement, getString, getString, getTime, getTime, getTime, getTime, getTimestamp, getTimestamp, getTimestamp, getTimestamp, getUnicodeStream, getUnicodeStream, getURL, getURL, getWarnings, insertRow, isAfterLast, isBeforeFirst, isClosed, isFirst, isLast, last, moveToCurrentRow, moveToInsertRow, next, previous, refreshRow, relative, rowDeleted, rowInserted, rowUpdated, updateArray, updateArray, updateAsciiStream, updateAsciiStream, updateAsciiStream, updateAsciiStream, updateAsciiStream, updateAsciiStream, updateBigDecimal, updateBigDecimal, updateBinaryStream, updateBinaryStream, updateBinaryStream, updateBinaryStream, updateBinaryStream, updateBinaryStream, updateBlob, updateBlob, updateBlob, updateBlob, updateBlob, updateBlob, updateBoolean, updateBoolean, updateByte, updateByte, updateBytes, updateBytes, updateCharacterStream, updateCharacterStream, updateCharacterStream, updateCharacterStream, updateCharacterStream, updateCharacterStream, updateClob, updateClob, updateClob, updateClob, updateClob, updateClob, updateDate, updateDate, updateDouble, updateDouble, updateFloat, updateFloat, updateInt, updateInt, updateLong, updateLong, updateNCharacterStream, updateNCharacterStream, updateNCharacterStream, updateNCharacterStream, updateNClob, updateNClob, updateNClob, updateNClob, updateNClob, updateNClob, updateNString, updateNString, updateNull, updateNull, updateObject, updateObject, updateObject, updateObject, updateObject, updateObject, updateObject, updateObject, updateRef, updateRef, updateRow, updateRowId, updateRowId, updateShort, updateShort, updateSQLXML, updateSQLXML, updateString, updateString, updateTime, updateTime, updateTimestamp, updateTimestamp, wasNull`

### Methods inherited from interface javax.sql.RowSet

`execute`

### Methods inherited from interface java.sql.Wrapper

`isWrapperFor, unwrap`

### Field Detail

#### ev_CursorMoved

    protected static final int ev_CursorMoved

See Also:
  Constant Field Values

#### ev_RowChanged

    protected static final int ev_RowChanged

See Also:
  Constant Field Values

#### ev_RowSetChanged

    protected static final int ev_RowSetChanged

See Also:
  Constant Field Values

#### map

    protected java.util.Map<java.lang.String,java.lang.Class<?>> map

### Constructor Detail

#### BaseRowSet

    public BaseRowSet​()

### Method Detail

#### close

    public void close​()
               throws java.sql.SQLException

Specified by:
  `close` in interface `java.lang.AutoCloseable`
Specified by:
  `close` in interface `java.sql.ResultSet`
Throws:
  `java.sql.SQLException`

#### addRowSetListener

    public void addRowSetListener​(javax.sql.RowSetListener rowsetlistener)

RowSet listener registration. Listeners are notified when an event occurs.

Specified by:
  `addRowSetListener` in interface `javax.sql.RowSet`
Parameters:
  `rowsetlistener` - an event listener

#### removeRowSetListener

    public void removeRowSetListener​(javax.sql.RowSetListener rowsetlistener)

RowSet listener deregistration.

Specified by:
  `removeRowSetListener` in interface `javax.sql.RowSet`
Parameters:
  `rowsetlistener` - an event listener

#### clearParameters

    public void clearParameters​()
                         throws java.sql.SQLException

In general, parameter values remain in force for repeated use of a RowSet. Setting a parameter value automatically clears its previous value. However, in some cases it is useful to immediately release the resources used by the current parameter values; this can be done by calling clearParameters.

Specified by:
  `clearParameters` in interface `javax.sql.RowSet`
Throws:
  `java.sql.SQLException` - if a database-access error occurs.

#### getCommand

    public java.lang.String getCommand​()

Get the rowset's command property. The command property contains a command string that can be executed to fill the rowset with data. The default value is null.

Specified by:
  `getCommand` in interface `javax.sql.RowSet`
Returns:
  the command string, may be null

#### getConcurrency

    public int getConcurrency​()
                       throws java.sql.SQLException

Get the rowset concurrency.

Specified by:
  `getConcurrency` in interface `java.sql.ResultSet`
Throws:
  `java.sql.SQLException` - if a database-access error occurs.

#### getDataSourceName

    public java.lang.String getDataSourceName​()

The JNDI name that identifies a JDBC data source. Users should set either the url or data source name properties. The most recent property set is used to get a connection.

Specified by:
  `getDataSourceName` in interface `javax.sql.RowSet`
Returns:
  a data source name

#### getEscapeProcessing

    public boolean getEscapeProcessing​()
                                throws java.sql.SQLException

If escape scanning is on (the default), the driver will do escape substitution before sending the SQL to the database.

Specified by:
  `getEscapeProcessing` in interface `javax.sql.RowSet`
Returns:
  true if enabled; false if disabled
Throws:
  `java.sql.SQLException` - if a database-access error occurs.

#### getFetchDirection

    public int getFetchDirection​()
                          throws java.sql.SQLException

Determine the fetch direction.

Specified by:
  `getFetchDirection` in interface `java.sql.ResultSet`
Returns:
  the default fetch direction
Throws:
  `java.sql.SQLException` - if a database-access error occurs

#### getFetchSize

    public int getFetchSize​()
                     throws java.sql.SQLException

Determine the default fetch size.

Specified by:
  `getFetchSize` in interface `java.sql.ResultSet`
Throws:
  `java.sql.SQLException`

#### getMaxFieldSize

    public int getMaxFieldSize​()
                        throws java.sql.SQLException

The maxFieldSize limit (in bytes) is the maximum amount of data returned for any column value; it only applies to BINARY, VARBINARY, LONGVARBINARY, CHAR, VARCHAR, and LONGVARCHAR columns. If the limit is exceeded, the excess data is silently discarded.

Specified by:
  `getMaxFieldSize` in interface `javax.sql.RowSet`
Returns:
  the current max column size limit; zero means unlimited
Throws:
  `java.sql.SQLException` - if a database-access error occurs.

#### getMaxRows

    public int getMaxRows​()
                   throws java.sql.SQLException

The maxRows limit is the maximum number of rows that a RowSet can contain. If the limit is exceeded, the excess rows are silently dropped.

Specified by:
  `getMaxRows` in interface `javax.sql.RowSet`
Returns:
  the current max row limit; zero means unlimited
Throws:
  `java.sql.SQLException` - if a database-access error occurs.

#### getParams

    public java.lang.Object[] getParams​()
                                 throws java.sql.SQLException

Get the parameters that were set on the rowset.

Returns:
  an array of parameters
Throws:
  `java.sql.SQLException` - if a database-access error occurs.

#### getPassword

    public java.lang.String getPassword​()

The password used to create a database connection. The password property is set at runtime before calling execute(). It is not usually part of the serialized state of a rowset object.

Specified by:
  `getPassword` in interface `javax.sql.RowSet`
Returns:
  a password

#### getQueryTimeout

    public int getQueryTimeout​()
                        throws java.sql.SQLException

The queryTimeout limit is the number of seconds the driver will wait for a Statement to execute. If the limit is exceeded, a SQLException is thrown.

Specified by:
  `getQueryTimeout` in interface `javax.sql.RowSet`
Returns:
  the current query timeout limit in seconds; zero means unlimited
Throws:
  `java.sql.SQLException` - if a database-access error occurs.

#### getTransactionIsolation

    public int getTransactionIsolation​()

The transaction isolation property contains the JDBC transaction isolation level used.

Specified by:
  `getTransactionIsolation` in interface `javax.sql.RowSet`
Returns:
  the transaction isolation level

#### getType

    public int getType​()
                throws java.sql.SQLException

Return the type of this result set.

Specified by:
  `getType` in interface `java.sql.ResultSet`
Returns:
  TYPE_FORWARD_ONLY, TYPE_SCROLL_INSENSITIVE, or TYPE_SCROLL_SENSITIVE
Throws:
  `java.sql.SQLException` - if a database-access error occurs

#### getTypeMap

    public java.util.Map<java.lang.String,java.lang.Class<?>> getTypeMap​()
                                                                  throws java.sql.SQLException

Get the type-map object associated with this rowset. By default, the map returned is empty.

Specified by:
  `getTypeMap` in interface `javax.sql.RowSet`
Returns:
  a map object
Throws:
  `java.sql.SQLException` - if a database-access error occurs.

#### getUrl

    public java.lang.String getUrl​()
                            throws java.sql.SQLException

Get the url used to create a JDBC connection. The default value is null.

Specified by:
  `getUrl` in interface `javax.sql.RowSet`
Returns:
  a string url
Throws:
  `java.sql.SQLException` - if a database-access error occurs.

#### getUsername

    public java.lang.String getUsername​()

The username used to create a database connection. The username property is set at runtime before calling execute(). It is not usually part of the serialized state of a rowset object.

Specified by:
  `getUsername` in interface `javax.sql.RowSet`
Returns:
  a user name

#### isReadOnly

    public boolean isReadOnly​()

A rowset may be read-only. Attempts to update a read-only rowset will result in an SQLException being thrown. Rowsets are updateable, by default, if updates are possible.

Specified by:
  `isReadOnly` in interface `javax.sql.RowSet`
Returns:
  true if updatable, false otherwise

#### setArray

    public void setArray​(int parameterIndex,
                         java.sql.Array x)
                  throws java.sql.SQLException

Set an Array parameter.

Specified by:
  `setArray` in interface `javax.sql.RowSet`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - an object representing an SQL array
Throws:
  `java.sql.SQLException`

#### setAsciiStream

    public void setAsciiStream​(int parameterIndex,
                               java.io.InputStream x,
                               int length)
                        throws java.sql.SQLException

When a very large ASCII value is input to a LONGVARCHAR parameter, it may be more practical to send it via a java.io.InputStream. JDBC will read the data from the stream as needed, until it reaches end-of-file.

Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

Specified by:
  `setAsciiStream` in interface `javax.sql.RowSet`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - the java input stream which contains the ASCII parameter value
  `length` - the number of bytes in the stream
Throws:
  `java.sql.SQLException` - if a database-access error occurs.

#### setBigDecimal

    public void setBigDecimal​(int parameterIndex,
                              java.math.BigDecimal x)
                       throws java.sql.SQLException

Set a parameter to a java.lang.BigDecimal value.

Specified by:
  `setBigDecimal` in interface `javax.sql.RowSet`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - the parameter value
Throws:
  `java.sql.SQLException` - if a database-access error occurs.

#### setBinaryStream

    public void setBinaryStream​(int parameterIndex,
                                java.io.InputStream x,
                                int length)
                         throws java.sql.SQLException

When a very large binary value is input to a LONGVARBINARY parameter, it may be more practical to send it via a java.io.InputStream. JDBC will read the data from the stream as needed, until it reaches end-of-file.

Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

Specified by:
  `setBinaryStream` in interface `javax.sql.RowSet`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - the java input stream which contains the binary parameter value
  `length` - the number of bytes in the stream
Throws:
  `java.sql.SQLException` - if a database-access error occurs.

#### setBlob

    public void setBlob​(int parameterIndex,
                        java.sql.Blob x)
                 throws java.sql.SQLException

Set a BLOB parameter.

Specified by:
  `setBlob` in interface `javax.sql.RowSet`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - an object representing a BLOB
Throws:
  `java.sql.SQLException`

#### setBlob

    public void setBlob​(int parameterIndex,
                        java.io.InputStream inputStream,
                        long length)
                 throws java.sql.SQLException

Sets the designated parameter to a `InputStream` object. The inputstream must contain the number of characters specified by length otherwise a `SQLException` will be generated when the `PreparedStatement` is executed. This method differs from the `setBinaryStream (int, InputStream, int)` method because it informs the driver that the parameter value should be sent to the server as a `BLOB`. When the `setBinaryStream` method is used, the driver may have to do extra work to determine whether the parameter data should be sent to the server as a `LONGVARBINARY` or a `BLOB`

Specified by:
  `setBlob` in interface `javax.sql.RowSet`
Parameters:
  `parameterIndex` - index of the first parameter is 1, the second is 2, ...
  `inputStream` - An object that contains the data to set the parameter value to.
  `length` - the number of bytes in the parameter data.
Throws:
  `java.sql.SQLException` - if a database access error occurs, this method is called on a closed `PreparedStatement`, if parameterIndex does not correspond to a parameter marker in the SQL statement, if the length specified is less than zero or if the number of bytes in the inputstream does not match the specfied length.
  `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### setBlob

    public void setBlob​(int parameterIndex,
                        java.io.InputStream inputStream)
                 throws java.sql.SQLException

Sets the designated parameter to a `InputStream` object. This method differs from the `setBinaryStream (int, InputStream)` method because it informs the driver that the parameter value should be sent to the server as a `BLOB`. When the `setBinaryStream` method is used, the driver may have to do extra work to determine whether the parameter data should be sent to the server as a `LONGVARBINARY` or a `BLOB`

Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `setBlob` which takes a length parameter.

Specified by:
  `setBlob` in interface `javax.sql.RowSet`
Parameters:
  `parameterIndex` - index of the first parameter is 1, the second is 2, ...
  `inputStream` - An object that contains the data to set the parameter value to.
Throws:
  `java.sql.SQLException` - if a database access error occurs, this method is called on a closed `PreparedStatement` or if parameterIndex does not correspond to a parameter marker in the SQL statement,
  `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### setBlob

    public void setBlob​(java.lang.String parameterName,
                        java.io.InputStream inputStream,
                        long length)
                 throws java.sql.SQLException

Sets the designated parameter to a `InputStream` object. The `inputstream` must contain the number of characters specified by length, otherwise a `SQLException` will be generated when the `CallableStatement` is executed. This method differs from the `setBinaryStream (int, InputStream, int)` method because it informs the driver that the parameter value should be sent to the server as a `BLOB`. When the `setBinaryStream` method is used, the driver may have to do extra work to determine whether the parameter data should be sent to the server as a `LONGVARBINARY` or a `BLOB`

Specified by:
  `setBlob` in interface `javax.sql.RowSet`
Parameters:
  `parameterName` - the name of the parameter to be set the second is 2, ...
  `inputStream` - An object that contains the data to set the parameter value to.
  `length` - the number of bytes in the parameter data.
Throws:
  `java.sql.SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement, or if the length specified is less than zero; if the number of bytes in the inputstream does not match the specfied length; if a database access error occurs or this method is called on a closed `CallableStatement`
  `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### setBlob

    public void setBlob​(java.lang.String parameterName,
                        java.sql.Blob x)
                 throws java.sql.SQLException

Sets the designated parameter to the given `java.sql.Blob` object. The driver converts this to an SQL `BLOB` value when it sends it to the database.

Specified by:
  `setBlob` in interface `javax.sql.RowSet`
Parameters:
  `parameterName` - the name of the parameter
  `x` - a `Blob` object that maps an SQL `BLOB` value
Throws:
  `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `CallableStatement`
  `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### setBlob

    public void setBlob​(java.lang.String parameterName,
                        java.io.InputStream inputStream)
                 throws java.sql.SQLException

Sets the designated parameter to a `InputStream` object. This method differs from the `setBinaryStream (int, InputStream)` method because it informs the driver that the parameter value should be sent to the server as a `BLOB`. When the `setBinaryStream` method is used, the driver may have to do extra work to determine whether the parameter data should be send to the server as a `LONGVARBINARY` or a `BLOB`

Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `setBlob` which takes a length parameter.

Specified by:
  `setBlob` in interface `javax.sql.RowSet`
Parameters:
  `parameterName` - the name of the parameter
  `inputStream` - An object that contains the data to set the parameter value to.
Throws:
  `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `CallableStatement`
  `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### setClob

    public void setClob​(int parameterIndex,
                        java.io.Reader reader,
                        long length)
                 throws java.sql.SQLException

Sets the designated parameter to a `Reader` object. The reader must contain the number of characters specified by length otherwise a `SQLException` will be generated when the `PreparedStatement` is executed. This method differs from the `setCharacterStream (int, Reader, int)` method because it informs the driver that the parameter value should be sent to the server as a `CLOB`. When the `setCharacterStream` method is used, the driver may have to do extra work to determine whether the parameter data should be sent to the server as a `LONGVARCHAR` or a `CLOB`

Specified by:
  `setClob` in interface `javax.sql.RowSet`
Parameters:
  `parameterIndex` - index of the first parameter is 1, the second is 2, ...
  `reader` - An object that contains the data to set the parameter value to.
  `length` - the number of characters in the parameter data.
Throws:
  `java.sql.SQLException` - if a database access error occurs, this method is called on a closed `PreparedStatement`, if parameterIndex does not correspond to a parameter marker in the SQL statement, or if the length specified is less than zero.
  `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### setClob

    public void setClob​(int parameterIndex,
                        java.io.Reader reader)
                 throws java.sql.SQLException

Sets the designated parameter to a `Reader` object. This method differs from the `setCharacterStream (int, Reader)` method because it informs the driver that the parameter value should be sent to the server as a `CLOB`. When the `setCharacterStream` method is used, the driver may have to do extra work to determine whether the parameter data should be sent to the server as a `LONGVARCHAR` or a `CLOB`

Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `setClob` which takes a length parameter.

Specified by:
  `setClob` in interface `javax.sql.RowSet`
Parameters:
  `parameterIndex` - index of the first parameter is 1, the second is 2, ...
  `reader` - An object that contains the data to set the parameter value to.
Throws:
  `java.sql.SQLException` - if a database access error occurs, this method is called on a closed `PreparedStatement`or if parameterIndex does not correspond to a parameter marker in the SQL statement
  `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### setClob

    public void setClob​(java.lang.String parameterName,
                        java.io.Reader reader,
                        long length)
                 throws java.sql.SQLException

Sets the designated parameter to a `Reader` object. The `reader` must contain the number of characters specified by length otherwise a `SQLException` will be generated when the `CallableStatement` is executed. This method differs from the `setCharacterStream (int, Reader, int)` method because it informs the driver that the parameter value should be sent to the server as a `CLOB`. When the `setCharacterStream` method is used, the driver may have to do extra work to determine whether the parameter data should be send to the server as a `LONGVARCHAR` or a `CLOB`

Specified by:
  `setClob` in interface `javax.sql.RowSet`
Parameters:
  `parameterName` - the name of the parameter to be set
  `reader` - An object that contains the data to set the parameter value to.
  `length` - the number of characters in the parameter data.
Throws:
  `java.sql.SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if the length specified is less than zero; a database access error occurs or this method is called on a closed `CallableStatement`
  `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### setClob

    public void setClob​(java.lang.String parameterName,
                        java.sql.Clob x)
                 throws java.sql.SQLException

Sets the designated parameter to the given `java.sql.Clob` object. The driver converts this to an SQL `CLOB` value when it sends it to the database.

Specified by:
  `setClob` in interface `javax.sql.RowSet`
Parameters:
  `parameterName` - the name of the parameter
  `x` - a `Clob` object that maps an SQL `CLOB` value
Throws:
  `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `CallableStatement`
  `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### setClob

    public void setClob​(java.lang.String parameterName,
                        java.io.Reader reader)
                 throws java.sql.SQLException

Sets the designated parameter to a `Reader` object. This method differs from the `setCharacterStream (int, Reader)` method because it informs the driver that the parameter value should be sent to the server as a `CLOB`. When the `setCharacterStream` method is used, the driver may have to do extra work to determine whether the parameter data should be send to the server as a `LONGVARCHAR` or a `CLOB`

Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `setClob` which takes a length parameter.

Specified by:
  `setClob` in interface `javax.sql.RowSet`
Parameters:
  `parameterName` - the name of the parameter
  `reader` - An object that contains the data to set the parameter value to.
Throws:
  `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `CallableStatement`
  `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### setSQLXML

    public void setSQLXML​(int parameterIndex,
                          java.sql.SQLXML xmlObject)
                   throws java.sql.SQLException

Sets the designated parameter to the given `java.sql.SQLXML` object. The driver converts this to an SQL `XML` value when it sends it to the database.

Specified by:
  `setSQLXML` in interface `javax.sql.RowSet`
Parameters:
  `parameterIndex` - index of the first parameter is 1, the second is 2, ...
  `xmlObject` - a `SQLXML` object that maps an SQL `XML` value
Throws:
  `java.sql.SQLException` - if a database access error occurs, this method is called on a closed result set, the `java.xml.transform.Result`, `Writer` or `OutputStream` has not been closed for the `SQLXML` object or if there is an error processing the XML value. The `getCause` method of the exception may provide a more detailed exception, for example, if the stream does not contain valid XML.
Since:
  1.6

#### setSQLXML

    public void setSQLXML​(java.lang.String parameterName,
                          java.sql.SQLXML xmlObject)
                   throws java.sql.SQLException

Sets the designated parameter to the given `java.sql.SQLXML` object. The driver converts this to an `SQL XML` value when it sends it to the database.

Specified by:
  `setSQLXML` in interface `javax.sql.RowSet`
Parameters:
  `parameterName` - the name of the parameter
  `xmlObject` - a `SQLXML` object that maps an `SQL XML` value
Throws:
  `java.sql.SQLException` - if a database access error occurs, this method is called on a closed result set, the `java.xml.transform.Result`, `Writer` or `OutputStream` has not been closed for the `SQLXML` object or if there is an error processing the XML value. The `getCause` method of the exception may provide a more detailed exception, for example, if the stream does not contain valid XML.
Since:
  1.6

#### setRowId

    public void setRowId​(int parameterIndex,
                         java.sql.RowId x)
                  throws java.sql.SQLException

Sets the designated parameter to the given `java.sql.RowId` object. The driver converts this to a SQL `ROWID` value when it sends it to the database

Specified by:
  `setRowId` in interface `javax.sql.RowSet`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - the parameter value
Throws:
  `java.sql.SQLException` - if a database access error occurs
Since:
  1.6

#### setRowId

    public void setRowId​(java.lang.String parameterName,
                         java.sql.RowId x)
                  throws java.sql.SQLException

Sets the designated parameter to the given `java.sql.RowId` object. The driver converts this to a SQL `ROWID` when it sends it to the database.

Specified by:
  `setRowId` in interface `javax.sql.RowSet`
Parameters:
  `parameterName` - the name of the parameter
  `x` - the parameter value
Throws:
  `java.sql.SQLException` - if a database access error occurs
Since:
  1.6

#### setNString

    public void setNString​(int parameterIndex,
                           java.lang.String value)
                    throws java.sql.SQLException

Sets the designated paramter to the given `String` object. The driver converts this to a SQL `NCHAR` or `NVARCHAR` or `LONGNVARCHAR` value (depending on the argument's size relative to the driver's limits on `NVARCHAR` values) when it sends it to the database.

Specified by:
  `setNString` in interface `javax.sql.RowSet`
Parameters:
  `parameterIndex` - of the first parameter is 1, the second is 2, ...
  `value` - the parameter value
Throws:
  `java.sql.SQLException` - if the driver does not support national character sets; if the driver can detect that a data conversion error could occur ; or if a database access error occurs
Since:
  1.6

#### setNString

    public void setNString​(java.lang.String parameterName,
                           java.lang.String value)
                    throws java.sql.SQLException

Sets the designated paramter to the given `String` object. The driver converts this to a SQL `NCHAR` or `NVARCHAR` or `LONGNVARCHAR`

Specified by:
  `setNString` in interface `javax.sql.RowSet`
Parameters:
  `parameterName` - the name of the column to be set
  `value` - the parameter value
Throws:
  `java.sql.SQLException` - if the driver does not support national character sets; if the driver can detect that a data conversion error could occur; or if a database access error occurs
Since:
  1.6

#### setNCharacterStream

    public void setNCharacterStream​(int parameterIndex,
                                    java.io.Reader value,
                                    long length)
                             throws java.sql.SQLException

Sets the designated parameter to a `Reader` object. The `Reader` reads the data till end-of-file is reached. The driver does the necessary conversion from Java character format to the national character set in the database.

Specified by:
  `setNCharacterStream` in interface `javax.sql.RowSet`
Parameters:
  `parameterIndex` - of the first parameter is 1, the second is 2, ...
  `value` - the parameter value
  `length` - the number of characters in the parameter data.
Throws:
  `java.sql.SQLException` - if the driver does not support national character sets; if the driver can detect that a data conversion error could occur ; or if a database access error occurs
Since:
  1.6

#### setNCharacterStream

    public void setNCharacterStream​(java.lang.String parameterName,
                                    java.io.Reader value,
                                    long length)
                             throws java.sql.SQLException

Sets the designated parameter to a `Reader` object. The `Reader` reads the data till end-of-file is reached. The driver does the necessary conversion from Java character format to the national character set in the database.

Specified by:
  `setNCharacterStream` in interface `javax.sql.RowSet`
Parameters:
  `parameterName` - the name of the column to be set
  `value` - the parameter value
  `length` - the number of characters in the parameter data.
Throws:
  `java.sql.SQLException` - if the driver does not support national character sets; if the driver can detect that a data conversion error could occur; or if a database access error occurs
Since:
  1.6

#### setNCharacterStream

    public void setNCharacterStream​(java.lang.String parameterName,
                                    java.io.Reader value)
                             throws java.sql.SQLException

Sets the designated parameter to a `Reader` object. The `Reader` reads the data till end-of-file is reached. The driver does the necessary conversion from Java character format to the national character set in the database.

Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `setNCharacterStream` which takes a length parameter.

Specified by:
  `setNCharacterStream` in interface `javax.sql.RowSet`
Parameters:
  `parameterName` - the name of the parameter
  `value` - the parameter value
Throws:
  `java.sql.SQLException` - if the driver does not support national character sets; if the driver can detect that a data conversion error could occur ; if a database access error occurs; or this method is called on a closed `CallableStatement`
  `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### setNClob

    public void setNClob​(java.lang.String parameterName,
                         java.sql.NClob value)
                  throws java.sql.SQLException

Sets the designated parameter to a `java.sql.NClob` object. The object implements the `java.sql.NClob` interface. This `NClob` object maps to a SQL `NCLOB`.

Specified by:
  `setNClob` in interface `javax.sql.RowSet`
Parameters:
  `parameterName` - the name of the column to be set
  `value` - the parameter value
Throws:
  `java.sql.SQLException` - if the driver does not support national character sets; if the driver can detect that a data conversion error could occur; or if a database access error occurs
Since:
  1.6

#### setNClob

    public void setNClob​(java.lang.String parameterName,
                         java.io.Reader reader,
                         long length)
                  throws java.sql.SQLException

Sets the designated parameter to a `Reader` object. The `reader` must contain the number of characters specified by length otherwise a `SQLException` will be generated when the `CallableStatement` is executed. This method differs from the `setCharacterStream (int, Reader, int)` method because it informs the driver that the parameter value should be sent to the server as a `NCLOB`. When the `setCharacterStream` method is used, the driver may have to do extra work to determine whether the parameter data should be send to the server as a `LONGNVARCHAR` or a `NCLOB`

Specified by:
  `setNClob` in interface `javax.sql.RowSet`
Parameters:
  `parameterName` - the name of the parameter to be set
  `reader` - An object that contains the data to set the parameter value to.
  `length` - the number of characters in the parameter data.
Throws:
  `java.sql.SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if the length specified is less than zero; if the driver does not support national character sets; if the driver can detect that a data conversion error could occur; if a database access error occurs or this method is called on a closed `CallableStatement`
  `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### setNClob

    public void setNClob​(java.lang.String parameterName,
                         java.io.Reader reader)
                  throws java.sql.SQLException

Sets the designated parameter to a `Reader` object. This method differs from the `setCharacterStream (int, Reader)` method because it informs the driver that the parameter value should be sent to the server as a `NCLOB`. When the `setCharacterStream` method is used, the driver may have to do extra work to determine whether the parameter data should be send to the server as a `LONGNVARCHAR` or a `NCLOB`

Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `setNClob` which takes a length parameter.

Specified by:
  `setNClob` in interface `javax.sql.RowSet`
Parameters:
  `parameterName` - the name of the parameter
  `reader` - An object that contains the data to set the parameter value to.
Throws:
  `java.sql.SQLException` - if the driver does not support national character sets; if the driver can detect that a data conversion error could occur; if a database access error occurs or this method is called on a closed `CallableStatement`
  `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### setNClob

    public void setNClob​(int parameterIndex,
                         java.io.Reader reader,
                         long length)
                  throws java.sql.SQLException

Sets the designated parameter to a `Reader` object. The reader must contain the number of characters specified by length otherwise a `SQLException` will be generated when the `PreparedStatement` is executed. This method differs from the `setCharacterStream (int, Reader, int)` method because it informs the driver that the parameter value should be sent to the server as a `NCLOB`. When the `setCharacterStream` method is used, the driver may have to do extra work to determine whether the parameter data should be sent to the server as a `LONGNVARCHAR` or a `NCLOB`

Specified by:
  `setNClob` in interface `javax.sql.RowSet`
Parameters:
  `parameterIndex` - index of the first parameter is 1, the second is 2, ...
  `reader` - An object that contains the data to set the parameter value to.
  `length` - the number of characters in the parameter data.
Throws:
  `java.sql.SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if the length specified is less than zero; if the driver does not support national character sets; if the driver can detect that a data conversion error could occur; if a database access error occurs or this method is called on a closed `PreparedStatement`
  `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### setNClob

    public void setNClob​(int parameterIndex,
                         java.sql.NClob value)
                  throws java.sql.SQLException

Sets the designated parameter to a `java.sql.NClob` object. The driver converts this to a SQL `NCLOB` value when it sends it to the database.

Specified by:
  `setNClob` in interface `javax.sql.RowSet`
Parameters:
  `parameterIndex` - of the first parameter is 1, the second is 2, ...
  `value` - the parameter value
Throws:
  `java.sql.SQLException` - if the driver does not support national character sets; if the driver can detect that a data conversion error could occur ; or if a database access error occurs
Since:
  1.6

#### setNClob

    public void setNClob​(int parameterIndex,
                         java.io.Reader reader)
                  throws java.sql.SQLException

Sets the designated parameter to a `Reader` object. This method differs from the `setCharacterStream (int, Reader)` method because it informs the driver that the parameter value should be sent to the server as a `NCLOB`. When the `setCharacterStream` method is used, the driver may have to do extra work to determine whether the parameter data should be sent to the server as a `LONGNVARCHAR` or a `NCLOB`

Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `setNClob` which takes a length parameter.

Specified by:
  `setNClob` in interface `javax.sql.RowSet`
Parameters:
  `parameterIndex` - index of the first parameter is 1, the second is 2, ...
  `reader` - An object that contains the data to set the parameter value to.
Throws:
  `java.sql.SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if the driver does not support national character sets; if the driver can detect that a data conversion error could occur; if a database access error occurs or this method is called on a closed `PreparedStatement`
  `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### setBoolean

    public void setBoolean​(int parameterIndex,
                           boolean x)
                    throws java.sql.SQLException

Set a parameter to a Java boolean value.

Specified by:
  `setBoolean` in interface `javax.sql.RowSet`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - the parameter value
Throws:
  `java.sql.SQLException` - if a database-access error occurs.

#### setByte

    public void setByte​(int parameterIndex,
                        byte x)
                 throws java.sql.SQLException

Set a parameter to a Java byte value.

Specified by:
  `setByte` in interface `javax.sql.RowSet`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - the parameter value
Throws:
  `java.sql.SQLException` - if a database-access error occurs.

#### setBytes

    public void setBytes​(int parameterIndex,
                         byte[] x)
                  throws java.sql.SQLException

Set a parameter to a Java array of bytes.

Specified by:
  `setBytes` in interface `javax.sql.RowSet`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - the parameter value
Throws:
  `java.sql.SQLException` - if a database-access error occurs.

#### setCharacterStream

    public void setCharacterStream​(int parameterIndex,
                                   java.io.Reader x,
                                   int length)
                            throws java.sql.SQLException

When a very large UNICODE value is input to a LONGVARCHAR parameter, it may be more practical to send it via a java.io.Reader. JDBC will read the data from the stream as needed, until it reaches end-of-file.

Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

Specified by:
  `setCharacterStream` in interface `javax.sql.RowSet`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - the java reader which contains the UNICODE data
  `length` - the number of characters in the stream
Throws:
  `java.sql.SQLException` - if a database-access error occurs.

#### setAsciiStream

    public void setAsciiStream​(int parameterIndex,
                               java.io.InputStream x)
                        throws java.sql.SQLException

Sets the designated parameter in this `RowSet` object's command to the given input stream. When a very large ASCII value is input to a `LONGVARCHAR` parameter, it may be more practical to send it via a `java.io.InputStream`. Data will be read from the stream as needed until end-of-file is reached. The JDBC driver will do any necessary conversion from ASCII to the database char format.

Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `setAsciiStream` which takes a length parameter.

Specified by:
  `setAsciiStream` in interface `javax.sql.RowSet`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - the Java input stream that contains the ASCII parameter value
Throws:
  `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `PreparedStatement`
  `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### setAsciiStream

    public void setAsciiStream​(java.lang.String parameterName,
                               java.io.InputStream x)
                        throws java.sql.SQLException

Sets the designated parameter to the given input stream. When a very large ASCII value is input to a `LONGVARCHAR` parameter, it may be more practical to send it via a `java.io.InputStream`. Data will be read from the stream as needed until end-of-file is reached. The JDBC driver will do any necessary conversion from ASCII to the database char format.

Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `setAsciiStream` which takes a length parameter.

Specified by:
  `setAsciiStream` in interface `javax.sql.RowSet`
Parameters:
  `parameterName` - the name of the parameter
  `x` - the Java input stream that contains the ASCII parameter value
Throws:
  `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `CallableStatement`
  `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### setBinaryStream

    public void setBinaryStream​(int parameterIndex,
                                java.io.InputStream x)
                         throws java.sql.SQLException

Sets the designated parameter in this `RowSet` object's command to the given input stream. When a very large binary value is input to a `LONGVARBINARY` parameter, it may be more practical to send it via a `java.io.InputStream` object. The data will be read from the stream as needed until end-of-file is reached.

Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `setBinaryStream` which takes a length parameter.

Specified by:
  `setBinaryStream` in interface `javax.sql.RowSet`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - the java input stream which contains the binary parameter value
Throws:
  `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `PreparedStatement`
  `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### setBinaryStream

    public void setBinaryStream​(java.lang.String parameterName,
                                java.io.InputStream x)
                         throws java.sql.SQLException

Sets the designated parameter to the given input stream. When a very large binary value is input to a `LONGVARBINARY` parameter, it may be more practical to send it via a `java.io.InputStream` object. The data will be read from the stream as needed until end-of-file is reached.

Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `setBinaryStream` which takes a length parameter.

Specified by:
  `setBinaryStream` in interface `javax.sql.RowSet`
Parameters:
  `parameterName` - the name of the parameter
  `x` - the java input stream which contains the binary parameter value
Throws:
  `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `CallableStatement`
  `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### setCharacterStream

    public void setCharacterStream​(int parameterIndex,
                                   java.io.Reader reader)
                            throws java.sql.SQLException

Sets the designated parameter in this `RowSet` object's command to the given `Reader` object. When a very large UNICODE value is input to a `LONGVARCHAR` parameter, it may be more practical to send it via a `java.io.Reader` object. The data will be read from the stream as needed until end-of-file is reached. The JDBC driver will do any necessary conversion from UNICODE to the database char format.

Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `setCharacterStream` which takes a length parameter.

Specified by:
  `setCharacterStream` in interface `javax.sql.RowSet`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `reader` - the `java.io.Reader` object that contains the Unicode data
Throws:
  `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `PreparedStatement`
  `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### setCharacterStream

    public void setCharacterStream​(java.lang.String parameterName,
                                   java.io.Reader reader)
                            throws java.sql.SQLException

Sets the designated parameter to the given `Reader` object. When a very large UNICODE value is input to a `LONGVARCHAR` parameter, it may be more practical to send it via a `java.io.Reader` object. The data will be read from the stream as needed until end-of-file is reached. The JDBC driver will do any necessary conversion from UNICODE to the database char format.

Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `setCharacterStream` which takes a length parameter.

Specified by:
  `setCharacterStream` in interface `javax.sql.RowSet`
Parameters:
  `parameterName` - the name of the parameter
  `reader` - the `java.io.Reader` object that contains the Unicode data
Throws:
  `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `CallableStatement`
  `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### setNCharacterStream

    public void setNCharacterStream​(int parameterIndex,
                                    java.io.Reader value)
                             throws java.sql.SQLException

Sets the designated parameter in this `RowSet` object's command to a `Reader` object. The `Reader` reads the data till end-of-file is reached. The driver does the necessary conversion from Java character format to the national character set in the database.

Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `setNCharacterStream` which takes a length parameter.

Specified by:
  `setNCharacterStream` in interface `javax.sql.RowSet`
Parameters:
  `parameterIndex` - of the first parameter is 1, the second is 2, ...
  `value` - the parameter value
Throws:
  `java.sql.SQLException` - if the driver does not support national character sets; if the driver can detect that a data conversion error could occur ; if a database access error occurs; or this method is called on a closed `PreparedStatement`
  `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### setClob

    public void setClob​(int parameterIndex,
                        java.sql.Clob x)
                 throws java.sql.SQLException

Set a CLOB parameter.

Specified by:
  `setClob` in interface `javax.sql.RowSet`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - an object representing a CLOB
Throws:
  `java.sql.SQLException`

#### setDate

    public void setDate​(int parameterIndex,
                        java.sql.Date x)
                 throws java.sql.SQLException

Set a parameter to a java.sql.Date value.

Specified by:
  `setDate` in interface `javax.sql.RowSet`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - the parameter value
Throws:
  `java.sql.SQLException` - if a database-access error occurs.

#### setDate

    public void setDate​(int parameterIndex,
                        java.sql.Date x,
                        java.util.Calendar cal)
                 throws java.sql.SQLException

Set a parameter to a java.sql.Date value. The driver converts this to a SQL DATE value when it sends it to the database.

Specified by:
  `setDate` in interface `javax.sql.RowSet`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - the parameter value
Throws:
  `java.sql.SQLException` - if a database-access error occurs.

#### setDouble

    public void setDouble​(int parameterIndex,
                          double x)
                   throws java.sql.SQLException

Set a parameter to a Java double value.

Specified by:
  `setDouble` in interface `javax.sql.RowSet`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - the parameter value
Throws:
  `java.sql.SQLException` - if a database-access error occurs.

#### setFloat

    public void setFloat​(int parameterIndex,
                         float x)
                  throws java.sql.SQLException

Set a parameter to a Java float value. The driver converts this to a SQL FLOAT value when it sends it to the database.

Specified by:
  `setFloat` in interface `javax.sql.RowSet`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - the parameter value
Throws:
  `java.sql.SQLException` - if a database-access error occurs.

#### setInt

    public void setInt​(int parameterIndex,
                       int x)
                throws java.sql.SQLException

Set a parameter to a Java int value.

Specified by:
  `setInt` in interface `javax.sql.RowSet`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - the parameter value
Throws:
  `java.sql.SQLException` - if a database-access error occurs.

#### setLong

    public void setLong​(int parameterIndex,
                        long x)
                 throws java.sql.SQLException

Set a parameter to a Java long value.

Specified by:
  `setLong` in interface `javax.sql.RowSet`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - the parameter value
Throws:
  `java.sql.SQLException` - if a database-access error occurs.

#### setRef

    public void setRef​(int parameterIndex,
                       java.sql.Ref x)
                throws java.sql.SQLException

Set a REF(<structured-type>) parameter.

Specified by:
  `setRef` in interface `javax.sql.RowSet`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - an object representing data of an SQL REF Type
Throws:
  `java.sql.SQLException`

#### setShort

    public void setShort​(int parameterIndex,
                         short x)
                  throws java.sql.SQLException

Set a parameter to a Java short value.

Specified by:
  `setShort` in interface `javax.sql.RowSet`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - the parameter value
Throws:
  `java.sql.SQLException` - if a database-access error occurs.

#### setString

    public void setString​(int parameterIndex,
                          java.lang.String x)
                   throws java.sql.SQLException

Set a parameter to a Java String value.

Specified by:
  `setString` in interface `javax.sql.RowSet`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - the parameter value
Throws:
  `java.sql.SQLException` - if a database-access error occurs.

#### setURL

    public void setURL​(int parameterIndex,
                       java.net.URL x)
                throws java.sql.SQLException

Sets the designated parameter to the given `java.net.URL` value. The driver converts this to an SQL `DATALINK` value when it sends it to the database.

Specified by:
  `setURL` in interface `javax.sql.RowSet`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - the `java.net.URL` object to be set
Throws:
  `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `PreparedStatement`
  `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.4

#### setTime

    public void setTime​(int parameterIndex,
                        java.sql.Time x)
                 throws java.sql.SQLException

Set a parameter to a java.sql.Time value.

Specified by:
  `setTime` in interface `javax.sql.RowSet`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - the parameter value
Throws:
  `java.sql.SQLException` - if a database-access error occurs.

#### setTime

    public void setTime​(int parameterIndex,
                        java.sql.Time x,
                        java.util.Calendar cal)
                 throws java.sql.SQLException

Set a parameter to a java.sql.Time value. The driver converts this to a SQL TIME value when it sends it to the database.

Specified by:
  `setTime` in interface `javax.sql.RowSet`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - the parameter value
Throws:
  `java.sql.SQLException` - if a database-access error occurs.

#### setTimestamp

    public void setTimestamp​(int parameterIndex,
                             java.sql.Timestamp x)
                      throws java.sql.SQLException

Set a parameter to a java.sql.Timestamp value.

Specified by:
  `setTimestamp` in interface `javax.sql.RowSet`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - the parameter value
Throws:
  `java.sql.SQLException` - if a database-access error occurs.

#### setTimestamp

    public void setTimestamp​(int parameterIndex,
                             java.sql.Timestamp x,
                             java.util.Calendar cal)
                      throws java.sql.SQLException

Set a parameter to a java.sql.Timestamp value. The driver converts this to a SQL TIMESTAMP value when it sends it to the database.

Specified by:
  `setTimestamp` in interface `javax.sql.RowSet`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - the parameter value
Throws:
  `java.sql.SQLException` - if a database-access error occurs.

#### setUnicodeStream

    public void setUnicodeStream​(int parameterIndex,
                                 java.io.InputStream x,
                                 int length)
                          throws java.sql.SQLException

Deprecated.
When a very large UNICODE value is input to a LONGVARCHAR parameter, it may be more practical to send it via a java.io.InputStream. JDBC will read the data from the stream as needed, until it reaches end-of-file. The JDBC driver will do any necessary conversion from UNICODE to the database char format.

Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - the java input stream which contains the UNICODE parameter value
  `length` - the number of bytes in the stream
Throws:
  `java.sql.SQLException` - if a database-access error occurs.

#### setNull

    public void setNull​(int parameterIndex,
                        int sqlType)
                 throws java.sql.SQLException

Set a parameter to SQL NULL.

Note: You must specify the parameter's SQL type.

Specified by:
  `setNull` in interface `javax.sql.RowSet`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `sqlType` - SQL type code defined by java.sql.Types
Throws:
  `java.sql.SQLException` - if a database-access error occurs.

#### setNull

    public void setNull​(int parameterIndex,
                        int sqlType,
                        java.lang.String typeName)
                 throws java.sql.SQLException

Sets the designated parameter to SQL NULL. This version of setNull should be used for user-named types and REF type parameters. Examples of user-named types include: STRUCT, DISTINCT, JAVA_OBJECT, and named array types.

Note: To be portable, applications must give the SQL type code and the fully-qualified SQL type name when specifying a NULL user-defined or REF parameter. In the case of a user-named type the name is the type name of the parameter itself. For a REF parameter the name is the type name of the referenced type. If a JDBC driver does not need the type code or type name information, it may ignore it. Although it is intended for user-named and Ref parameters, this method may be used to set a null parameter of any JDBC type. If the parameter does not have a user-named or REF type, the given typeName is ignored.

Specified by:
  `setNull` in interface `javax.sql.RowSet`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `sqlType` - a value from java.sql.Types
  `typeName` - the fully-qualified name of an SQL user-named type, ignored if the parameter is not a user-named type or REF
Throws:
  `java.sql.SQLException` - if a database access error occurs

#### setObject

    public void setObject​(int parameterIndex,
                          java.lang.Object x)
                   throws java.sql.SQLException

Set the value of a parameter using an object; use the java.lang equivalent objects for integral values.

The JDBC specification specifies a standard mapping from Java Object types to SQL types. The given argument java object will be converted to the corresponding SQL type before being sent to the database.

Note that this method may be used to pass datatabase specific abstract data types, by using a Driver specific Java type. If the object is of a class implementing SQLData, the rowset should call its method writeSQL() to write it to the SQL data stream. else If the object is of a class implementing Ref, Blob, Clob, Struct, or Array then pass it to the database as a value of the corresponding SQL type. Raise an exception if there is an ambiguity, for example, if the object is of a class implementing more than one of those interfaces.

Specified by:
  `setObject` in interface `javax.sql.RowSet`
Parameters:
  `parameterIndex` - The first parameter is 1, the second is 2, ...
  `x` - The object containing the input parameter value
Throws:
  `java.sql.SQLException` - if a database-access error occurs.

#### setObject

    public void setObject​(int parameterIndex,
                          java.lang.Object x,
                          int targetSqlType)
                   throws java.sql.SQLException

This method is like setObject above, but the scale used is the scale of the second parameter. Scalar values have a scale of zero. Literal values have the scale present in the literal. While it is supported, it is not recommended that this method not be called with floating point input values.

Specified by:
  `setObject` in interface `javax.sql.RowSet`
Throws:
  `java.sql.SQLException` - if a database-access error occurs.

#### setObject

    public void setObject​(int parameterIndex,
                          java.lang.Object x,
                          int targetSqlType,
                          int scale)
                   throws java.sql.SQLException

Set the value of a parameter using an object; use the java.lang equivalent objects for integral values.

The given Java object will be converted to the targetSqlType before being sent to the database. If the object is of a class implementing SQLData, the rowset should call its method writeSQL() to write it to the SQL data stream. else If the object is of a class implementing Ref, Blob, Clob, Struct, or Array then pass it to the database as a value of the corresponding SQL type.

Note that this method may be used to pass datatabase- specific abstract data types.

Specified by:
  `setObject` in interface `javax.sql.RowSet`
Parameters:
  `parameterIndex` - The first parameter is 1, the second is 2, ...
  `x` - The object containing the input parameter value
  `targetSqlType` - The SQL type (as defined in java.sql.Types) to be sent to the database. The scale argument may further qualify this type.
  `scale` - For java.sql.Types.DECIMAL or java.sql.Types.NUMERIC types this is the number of digits after the decimal. For all other types this value will be ignored,
Throws:
  `java.sql.SQLException` - if a database-access error occurs.
See Also:
  `Types`

#### setNull

    public void setNull​(java.lang.String parameterName,
                        int sqlType)
                 throws java.sql.SQLException

Sets the designated parameter to SQL `NULL`.

Note: You must specify the parameter's SQL type.

Specified by:
  `setNull` in interface `javax.sql.RowSet`
Parameters:
  `parameterName` - the name of the parameter
  `sqlType` - the SQL type code defined in `java.sql.Types`
Throws:
  `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `CallableStatement`
  `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.4

#### setNull

    public void setNull​(java.lang.String parameterName,
                        int sqlType,
                        java.lang.String typeName)
                 throws java.sql.SQLException

Sets the designated parameter to SQL `NULL`. This version of the method `setNull` should be used for user-defined types and REF type parameters. Examples of user-defined types include: STRUCT, DISTINCT, JAVA_OBJECT, and named array types.

Note: To be portable, applications must give the SQL type code and the fully-qualified SQL type name when specifying a NULL user-defined or REF parameter. In the case of a user-defined type the name is the type name of the parameter itself. For a REF parameter, the name is the type name of the referenced type. If a JDBC driver does not need the type code or type name information, it may ignore it. Although it is intended for user-defined and Ref parameters, this method may be used to set a null parameter of any JDBC type. If the parameter does not have a user-defined or REF type, the given typeName is ignored.

Specified by:
  `setNull` in interface `javax.sql.RowSet`
Parameters:
  `parameterName` - the name of the parameter
  `sqlType` - a value from `java.sql.Types`
  `typeName` - the fully-qualified name of an SQL user-defined type; ignored if the parameter is not a user-defined type or SQL `REF` value
Throws:
  `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `CallableStatement`
  `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.4

#### setBoolean

    public void setBoolean​(java.lang.String parameterName,
                           boolean x)
                    throws java.sql.SQLException

Sets the designated parameter to the given Java `boolean` value. The driver converts this to an SQL `BIT` or `BOOLEAN` value when it sends it to the database.

Specified by:
  `setBoolean` in interface `javax.sql.RowSet`
Parameters:
  `parameterName` - the name of the parameter
  `x` - the parameter value
Throws:
  `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `CallableStatement`
  `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.4
See Also:
  `ResultSet.getBoolean(int)`

#### setByte

    public void setByte​(java.lang.String parameterName,
                        byte x)
                 throws java.sql.SQLException

Sets the designated parameter to the given Java `byte` value. The driver converts this to an SQL `TINYINT` value when it sends it to the database.

Specified by:
  `setByte` in interface `javax.sql.RowSet`
Parameters:
  `parameterName` - the name of the parameter
  `x` - the parameter value
Throws:
  `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `CallableStatement`
  `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.4
See Also:
  `ResultSet.getByte(int)`

#### setShort

    public void setShort​(java.lang.String parameterName,
                         short x)
                  throws java.sql.SQLException

Sets the designated parameter to the given Java `short` value. The driver converts this to an SQL `SMALLINT` value when it sends it to the database.

Specified by:
  `setShort` in interface `javax.sql.RowSet`
Parameters:
  `parameterName` - the name of the parameter
  `x` - the parameter value
Throws:
  `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `CallableStatement`
  `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.4
See Also:
  `ResultSet.getShort(int)`

#### setInt

    public void setInt​(java.lang.String parameterName,
                       int x)
                throws java.sql.SQLException

Sets the designated parameter to the given Java `int` value. The driver converts this to an SQL `INTEGER` value when it sends it to the database.

Specified by:
  `setInt` in interface `javax.sql.RowSet`
Parameters:
  `parameterName` - the name of the parameter
  `x` - the parameter value
Throws:
  `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `CallableStatement`
  `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.4
See Also:
  `ResultSet.getInt(int)`

#### setLong

    public void setLong​(java.lang.String parameterName,
                        long x)
                 throws java.sql.SQLException

Sets the designated parameter to the given Java `long` value. The driver converts this to an SQL `BIGINT` value when it sends it to the database.

Specified by:
  `setLong` in interface `javax.sql.RowSet`
Parameters:
  `parameterName` - the name of the parameter
  `x` - the parameter value
Throws:
  `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `CallableStatement`
  `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.4
See Also:
  `ResultSet.getLong(int)`

#### setFloat

    public void setFloat​(java.lang.String parameterName,
                         float x)
                  throws java.sql.SQLException

Sets the designated parameter to the given Java `float` value. The driver converts this to an SQL `FLOAT` value when it sends it to the database.

Specified by:
  `setFloat` in interface `javax.sql.RowSet`
Parameters:
  `parameterName` - the name of the parameter
  `x` - the parameter value
Throws:
  `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `CallableStatement`
  `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.4
See Also:
  `ResultSet.getFloat(int)`

#### setDouble

    public void setDouble​(java.lang.String parameterName,
                          double x)
                   throws java.sql.SQLException

Sets the designated parameter to the given Java `double` value. The driver converts this to an SQL `DOUBLE` value when it sends it to the database.

Specified by:
  `setDouble` in interface `javax.sql.RowSet`
Parameters:
  `parameterName` - the name of the parameter
  `x` - the parameter value
Throws:
  `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `CallableStatement`
  `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.4
See Also:
  `ResultSet.getDouble(int)`

#### setBigDecimal

    public void setBigDecimal​(java.lang.String parameterName,
                              java.math.BigDecimal x)
                       throws java.sql.SQLException

Sets the designated parameter to the given `java.math.BigDecimal` value. The driver converts this to an SQL `NUMERIC` value when it sends it to the database.

Specified by:
  `setBigDecimal` in interface `javax.sql.RowSet`
Parameters:
  `parameterName` - the name of the parameter
  `x` - the parameter value
Throws:
  `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `CallableStatement`
  `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.4
See Also:
  `ResultSet.getBigDecimal(int, int)`

#### setString

    public void setString​(java.lang.String parameterName,
                          java.lang.String x)
                   throws java.sql.SQLException

Sets the designated parameter to the given Java `String` value. The driver converts this to an SQL `VARCHAR` or `LONGVARCHAR` value (depending on the argument's size relative to the driver's limits on `VARCHAR` values) when it sends it to the database.

Specified by:
  `setString` in interface `javax.sql.RowSet`
Parameters:
  `parameterName` - the name of the parameter
  `x` - the parameter value
Throws:
  `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `CallableStatement`
  `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.4
See Also:
  `ResultSet.getString(int)`

#### setBytes

    public void setBytes​(java.lang.String parameterName,
                         byte[] x)
                  throws java.sql.SQLException

Sets the designated parameter to the given Java array of bytes. The driver converts this to an SQL `VARBINARY` or `LONGVARBINARY` (depending on the argument's size relative to the driver's limits on `VARBINARY` values) when it sends it to the database.

Specified by:
  `setBytes` in interface `javax.sql.RowSet`
Parameters:
  `parameterName` - the name of the parameter
  `x` - the parameter value
Throws:
  `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `CallableStatement`
  `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.4
See Also:
  `ResultSet.getBytes(int)`

#### setTimestamp

    public void setTimestamp​(java.lang.String parameterName,
                             java.sql.Timestamp x)
                      throws java.sql.SQLException

Sets the designated parameter to the given `java.sql.Timestamp` value. The driver converts this to an SQL `TIMESTAMP` value when it sends it to the database.

Specified by:
  `setTimestamp` in interface `javax.sql.RowSet`
Parameters:
  `parameterName` - the name of the parameter
  `x` - the parameter value
Throws:
  `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `CallableStatement`
  `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.4
See Also:
  `ResultSet.getTimestamp(int)`

#### setAsciiStream

    public void setAsciiStream​(java.lang.String parameterName,
                               java.io.InputStream x,
                               int length)
                        throws java.sql.SQLException

Sets the designated parameter to the given input stream, which will have the specified number of bytes. When a very large ASCII value is input to a `LONGVARCHAR` parameter, it may be more practical to send it via a `java.io.InputStream`. Data will be read from the stream as needed until end-of-file is reached. The JDBC driver will do any necessary conversion from ASCII to the database char format.

Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

Specified by:
  `setAsciiStream` in interface `javax.sql.RowSet`
Parameters:
  `parameterName` - the name of the parameter
  `x` - the Java input stream that contains the ASCII parameter value
  `length` - the number of bytes in the stream
Throws:
  `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `CallableStatement`
  `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.4

#### setBinaryStream

    public void setBinaryStream​(java.lang.String parameterName,
                                java.io.InputStream x,
                                int length)
                         throws java.sql.SQLException

Sets the designated parameter to the given input stream, which will have the specified number of bytes. When a very large binary value is input to a `LONGVARBINARY` parameter, it may be more practical to send it via a `java.io.InputStream` object. The data will be read from the stream as needed until end-of-file is reached.

Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

Specified by:
  `setBinaryStream` in interface `javax.sql.RowSet`
Parameters:
  `parameterName` - the name of the parameter
  `x` - the java input stream which contains the binary parameter value
  `length` - the number of bytes in the stream
Throws:
  `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `CallableStatement`
  `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.4

#### setCharacterStream

    public void setCharacterStream​(java.lang.String parameterName,
                                   java.io.Reader reader,
                                   int length)
                            throws java.sql.SQLException

Sets the designated parameter to the given `Reader` object, which is the given number of characters long. When a very large UNICODE value is input to a `LONGVARCHAR` parameter, it may be more practical to send it via a `java.io.Reader` object. The data will be read from the stream as needed until end-of-file is reached. The JDBC driver will do any necessary conversion from UNICODE to the database char format.

Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

Specified by:
  `setCharacterStream` in interface `javax.sql.RowSet`
Parameters:
  `parameterName` - the name of the parameter
  `reader` - the `java.io.Reader` object that contains the UNICODE data used as the designated parameter
  `length` - the number of characters in the stream
Throws:
  `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `CallableStatement`
  `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.4

#### setObject

    public void setObject​(java.lang.String parameterName,
                          java.lang.Object x,
                          int targetSqlType,
                          int scale)
                   throws java.sql.SQLException

Sets the value of the designated parameter with the given object. The second argument must be an object type; for integral values, the `java.lang` equivalent objects should be used.

The given Java object will be converted to the given targetSqlType before being sent to the database. If the object has a custom mapping (is of a class implementing the interface `SQLData`), the JDBC driver should call the method `SQLData.writeSQL` to write it to the SQL data stream. If, on the other hand, the object is of a class implementing `Ref`, `Blob`, `Clob`, `NClob`, `Struct`, `java.net.URL`, or `Array`, the driver should pass it to the database as a value of the corresponding SQL type.

Note that this method may be used to pass datatabase- specific abstract data types.

Specified by:
  `setObject` in interface `javax.sql.RowSet`
Parameters:
  `parameterName` - the name of the parameter
  `x` - the object containing the input parameter value
  `targetSqlType` - the SQL type (as defined in java.sql.Types) to be sent to the database. The scale argument may further qualify this type.
  `scale` - for java.sql.Types.DECIMAL or java.sql.Types.NUMERIC types, this is the number of digits after the decimal point. For all other types, this value will be ignored.
Throws:
  `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `CallableStatement`
  `java.sql.SQLFeatureNotSupportedException` - if `targetSqlType` is a `ARRAY`, `BLOB`, `CLOB`, `DATALINK`, `JAVA_OBJECT`, `NCHAR`, `NCLOB`, `NVARCHAR`, `LONGNVARCHAR`, `REF`, `ROWID`, `SQLXML` or `STRUCT` data type and the JDBC driver does not support this data type
Since:
  1.4
See Also:
  `Types`, `ResultSet.getObject(int)`

#### setObject

    public void setObject​(java.lang.String parameterName,
                          java.lang.Object x,
                          int targetSqlType)
                   throws java.sql.SQLException

Sets the value of the designated parameter with the given object. This method is like the method `setObject` above, except that it assumes a scale of zero.

Specified by:
  `setObject` in interface `javax.sql.RowSet`
Parameters:
  `parameterName` - the name of the parameter
  `x` - the object containing the input parameter value
  `targetSqlType` - the SQL type (as defined in java.sql.Types) to be sent to the database
Throws:
  `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `CallableStatement`
  `java.sql.SQLFeatureNotSupportedException` - if `targetSqlType` is a `ARRAY`, `BLOB`, `CLOB`, `DATALINK`, `JAVA_OBJECT`, `NCHAR`, `NCLOB`, `NVARCHAR`, `LONGNVARCHAR`, `REF`, `ROWID`, `SQLXML` or `STRUCT` data type and the JDBC driver does not support this data type
Since:
  1.4
See Also:
  `ResultSet.getObject(int)`

#### setObject

    public void setObject​(java.lang.String parameterName,
                          java.lang.Object x)
                   throws java.sql.SQLException

Sets the value of the designated parameter with the given object. The second parameter must be of type `Object`; therefore, the `java.lang` equivalent objects should be used for built-in types.

The JDBC specification specifies a standard mapping from Java `Object` types to SQL types. The given argument will be converted to the corresponding SQL type before being sent to the database.

Note that this method may be used to pass datatabase- specific abstract data types, by using a driver-specific Java type. If the object is of a class implementing the interface `SQLData`, the JDBC driver should call the method `SQLData.writeSQL` to write it to the SQL data stream. If, on the other hand, the object is of a class implementing `Ref`, `Blob`, `Clob`, `NClob`, `Struct`, `java.net.URL`, or `Array`, the driver should pass it to the database as a value of the corresponding SQL type.

This method throws an exception if there is an ambiguity, for example, if the object is of a class implementing more than one of the interfaces named above.

Specified by:
  `setObject` in interface `javax.sql.RowSet`
Parameters:
  `parameterName` - the name of the parameter
  `x` - the object containing the input parameter value
Throws:
  `java.sql.SQLException` - if a database access error occurs, this method is called on a closed `CallableStatement` or if the given `Object` parameter is ambiguous
  `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.4
See Also:
  `ResultSet.getObject(int)`

#### setDate

    public void setDate​(java.lang.String parameterName,
                        java.sql.Date x)
                 throws java.sql.SQLException

Sets the designated parameter to the given `java.sql.Date` value using the default time zone of the virtual machine that is running the application. The driver converts this to an SQL `DATE` value when it sends it to the database.

Specified by:
  `setDate` in interface `javax.sql.RowSet`
Parameters:
  `parameterName` - the name of the parameter
  `x` - the parameter value
Throws:
  `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `CallableStatement`
  `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.4
See Also:
  `ResultSet.getDate(int)`

#### setDate

    public void setDate​(java.lang.String parameterName,
                        java.sql.Date x,
                        java.util.Calendar cal)
                 throws java.sql.SQLException

Sets the designated parameter to the given `java.sql.Date` value, using the given `Calendar` object. The driver uses the `Calendar` object to construct an SQL `DATE` value, which the driver then sends to the database. With a a `Calendar` object, the driver can calculate the date taking into account a custom timezone. If no `Calendar` object is specified, the driver uses the default timezone, which is that of the virtual machine running the application.

Specified by:
  `setDate` in interface `javax.sql.RowSet`
Parameters:
  `parameterName` - the name of the parameter
  `x` - the parameter value
  `cal` - the `Calendar` object the driver will use to construct the date
Throws:
  `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `CallableStatement`
  `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.4
See Also:
  `ResultSet.getDate(int)`

#### setTime

    public void setTime​(java.lang.String parameterName,
                        java.sql.Time x)
                 throws java.sql.SQLException

Sets the designated parameter to the given `java.sql.Time` value. The driver converts this to an SQL `TIME` value when it sends it to the database.

Specified by:
  `setTime` in interface `javax.sql.RowSet`
Parameters:
  `parameterName` - the name of the parameter
  `x` - the parameter value
Throws:
  `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `CallableStatement`
  `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.4
See Also:
  `ResultSet.getTime(int)`

#### setTime

    public void setTime​(java.lang.String parameterName,
                        java.sql.Time x,
                        java.util.Calendar cal)
                 throws java.sql.SQLException

Sets the designated parameter to the given `java.sql.Time` value, using the given `Calendar` object. The driver uses the `Calendar` object to construct an SQL `TIME` value, which the driver then sends to the database. With a a `Calendar` object, the driver can calculate the time taking into account a custom timezone. If no `Calendar` object is specified, the driver uses the default timezone, which is that of the virtual machine running the application.

Specified by:
  `setTime` in interface `javax.sql.RowSet`
Parameters:
  `parameterName` - the name of the parameter
  `x` - the parameter value
  `cal` - the `Calendar` object the driver will use to construct the time
Throws:
  `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `CallableStatement`
  `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.4
See Also:
  `ResultSet.getTime(int)`

#### setTimestamp

    public void setTimestamp​(java.lang.String parameterName,
                             java.sql.Timestamp x,
                             java.util.Calendar cal)
                      throws java.sql.SQLException

Sets the designated parameter to the given `java.sql.Timestamp` value, using the given `Calendar` object. The driver uses the `Calendar` object to construct an SQL `TIMESTAMP` value, which the driver then sends to the database. With a a `Calendar` object, the driver can calculate the timestamp taking into account a custom timezone. If no `Calendar` object is specified, the driver uses the default timezone, which is that of the virtual machine running the application.

Specified by:
  `setTimestamp` in interface `javax.sql.RowSet`
Parameters:
  `parameterName` - the name of the parameter
  `x` - the parameter value
  `cal` - the `Calendar` object the driver will use to construct the timestamp
Throws:
  `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `CallableStatement`
  `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.4
See Also:
  `ResultSet.getTimestamp(int)`

#### setCommand

    public void setCommand​(java.lang.String s)
                    throws java.sql.SQLException

Set the rowset's command property. This property is optional. The command property may not be needed when a rowset is produced by a data source that does not support commands, such as a spreadsheet.

Specified by:
  `setCommand` in interface `javax.sql.RowSet`
Parameters:
  `s` - a command string, may be null
Throws:
  `java.sql.SQLException` - if a database-access error occurs.

#### setConcurrency

    public void setConcurrency​(int i)
                        throws java.sql.SQLException

Set the rowset concurrency.

Specified by:
  `setConcurrency` in interface `javax.sql.RowSet`
Parameters:
  `i` - a value from ResultSet.CONCUR_XXX
Throws:
  `java.sql.SQLException` - if a database-access error occurs.

#### setDataSourceName

    public void setDataSourceName​(java.lang.String s)
                           throws java.sql.SQLException

Set the data source name.

Specified by:
  `setDataSourceName` in interface `javax.sql.RowSet`
Parameters:
  `s` - a data source name
Throws:
  `java.sql.SQLException` - if a database-access error occurs.

#### setEscapeProcessing

    public void setEscapeProcessing​(boolean flag)
                             throws java.sql.SQLException

If escape scanning is on (the default), the driver will do escape substitution before sending the SQL to the database.

Specified by:
  `setEscapeProcessing` in interface `javax.sql.RowSet`
Parameters:
  `flag` - true to enable; false to disable
Throws:
  `java.sql.SQLException` - if a database-access error occurs.

#### setFetchDirection

    public void setFetchDirection​(int direction)
                           throws java.sql.SQLException

Give a hint as to the direction in which the rows in this result set will be processed. The initial value is determined by the statement that produced the result set. The fetch direction may be changed at any time.

Specified by:
  `setFetchDirection` in interface `java.sql.ResultSet`
Throws:
  `java.sql.SQLException` - if a database-access error occurs, or the result set type is TYPE_FORWARD_ONLY and direction is not FETCH_FORWARD.

#### setFetchSize

    public void setFetchSize​(int rows)
                      throws java.sql.SQLException

Give the JDBC driver a hint as to the number of rows that should be fetched from the database when more rows are needed for this result set. If the fetch size specified is zero, then the JDBC driver ignores the value, and is free to make its own best guess as to what the fetch size should be. The default value is set by the statement that creates the result set. The fetch size may be changed at any time.

Specified by:
  `setFetchSize` in interface `java.sql.ResultSet`
Parameters:
  `rows` - the number of rows to fetch
Throws:
  `java.sql.SQLException` - if a database-access error occurs, or the condition 0 <= rows <= this.getMaxRows() is not satisfied.

#### setMaxFieldSize

    public void setMaxFieldSize​(int max)
                         throws java.sql.SQLException

The maxFieldSize limit (in bytes) is set to limit the size of data that can be returned for any column value; it only applies to BINARY, VARBINARY, LONGVARBINARY, CHAR, VARCHAR, and LONGVARCHAR fields. If the limit is exceeded, the excess data is silently discarded. For maximum portability use values greater than 256.

Specified by:
  `setMaxFieldSize` in interface `javax.sql.RowSet`
Parameters:
  `max` - the new max column size limit; zero means unlimited
Throws:
  `java.sql.SQLException` - if a database-access error occurs.

#### setMaxRows

    public void setMaxRows​(int max)
                    throws java.sql.SQLException

The maxRows limit is set to limit the number of rows that any RowSet can contain. If the limit is exceeded, the excess rows are silently dropped.

Specified by:
  `setMaxRows` in interface `javax.sql.RowSet`
Parameters:
  `max` - the new max rows limit; zero means unlimited
Throws:
  `java.sql.SQLException` - if a database-access error occurs.

#### setQueryTimeout

    public void setQueryTimeout​(int seconds)
                         throws java.sql.SQLException

The queryTimeout limit is the number of seconds the driver will wait for a Statement to execute. If the limit is exceeded, a SQLException is thrown.

Specified by:
  `setQueryTimeout` in interface `javax.sql.RowSet`
Parameters:
  `seconds` - the new query timeout limit in seconds; zero means unlimited
Throws:
  `java.sql.SQLException` - if a database-access error occurs.

#### setReadOnly

    public void setReadOnly​(boolean value)
                     throws java.sql.SQLException

Set the read-onlyness of the rowset

Specified by:
  `setReadOnly` in interface `javax.sql.RowSet`
Parameters:
  `value` - true if read-only, false otherwise
Throws:
  `java.sql.SQLException` - if a database-access error occurs.

#### setPassword

    public void setPassword​(java.lang.String s)
                     throws java.sql.SQLException

Set the password.

Specified by:
  `setPassword` in interface `javax.sql.RowSet`
Parameters:
  `s` - the password string
Throws:
  `java.sql.SQLException` - if a database-access error occurs.

#### setTransactionIsolation

    public void setTransactionIsolation​(int value)
                                 throws java.sql.SQLException

Set the transaction isolation.

Specified by:
  `setTransactionIsolation` in interface `javax.sql.RowSet`
Parameters:
  `value` - the transaction isolation level
Throws:
  `java.sql.SQLException` - if a database-access error occurs.

#### setType

    public void setType​(int value)
                 throws java.sql.SQLException

Set the type of this result set.

Specified by:
  `setType` in interface `javax.sql.RowSet`
Parameters:
  `value` - may be TYPE_FORWARD_ONLY, TYPE_SCROLL_INSENSITIVE, or TYPE_SCROLL_SENSITIVE
Throws:
  `java.sql.SQLException` - if a database-access error occurs

#### setTypeMap

    public void setTypeMap​(java.util.Map<java.lang.String,java.lang.Class<?>> value)
                    throws java.sql.SQLException

Install a type-map object as the default type-map for this rowset.

Specified by:
  `setTypeMap` in interface `javax.sql.RowSet`
Parameters:
  `value` - a map object
Throws:
  `java.sql.SQLException` - if a database-access error occurs.

#### setUrl

    public void setUrl​(java.lang.String s)
                throws java.sql.SQLException

Set the url used to create a connection. Setting this property is optional. If a url is used, a JDBC driver that accepts the url must be loaded by the application before the rowset is used to connect to a database. The rowset will use the url internally to create a database connection when reading or writing data. Either a url or a data source name is used to create a connection, whichever was specified most recently.

Specified by:
  `setUrl` in interface `javax.sql.RowSet`
Parameters:
  `s` - a string value, may be null
Throws:
  `java.sql.SQLException` - if a database-access error occurs.

#### setUsername

    public void setUsername​(java.lang.String s)
                     throws java.sql.SQLException

Set the user name.

Specified by:
  `setUsername` in interface `javax.sql.RowSet`
Parameters:
  `s` - a user name
Throws:
  `java.sql.SQLException` - if a database-access error occurs.

#### notifyListener

    protected void notifyListener​(int event)

#### getParam

    protected BaseRowSet.Parameter getParam​(int paramIndex)
                                     throws java.sql.SQLException

Throws:
  `java.sql.SQLException`